/* << HighC V1.7 >> [FM-TOWNS] **********************************************
*
*	̨(\)
*	----------------------------------------------------------------------
*	Programmed by Y.Hirata ( NIFTY-ID: NAB03321  pIpI )
*
*	NOTE: TAB=4
****************************************************************************/

#include <string.h>		/*  strlen,strcpy,memcpy	*/
#include <stdarg.h>		/*  va_list,va_*	*/
#include <stdio.h>		/*  vsprintf		*/
#include <msdos.cf>		/*  getds			*/
#include "egbtxt.h"		/*  egb.h,錾		*/

char	Gwork[EgbWorkSize] ;					/*  EGBƗ̈			*/
int		__gdotx = 8 ;							/*  ̉		*/
int		__gdoty = 16 ;							/*  ̏c		*/
int		__gdots = 0 ;							/*  ԋޯĐ	*/
int		__gtype = F_ROM ;						/*  \			*/
char	__gstrbuf[128] ;						/*  `p		*/

#define	TRUE				1
#define	FALSE				0

void pset( int x,int y )
/*===========================================================================
*	_`
===========================================================================*/
{
	struct {
		short int	n ;			/*  W_	*/
		short int	x ;			/*  XW		*/
		short int	y ;			/*  YW		*/
	} para ;									/*  EGB֐p		*/

	para.n = 1 ;
	para.x = x ;
	para.y = y ;
	EGB_pset( Gwork,(char *)&para ) ;			/*  _`				*/
}

void line( int x1,int y1,int x2,int y2 )
/*===========================================================================
*	`
===========================================================================*/
{
	struct {
		short int	n ;			/*  W_	*/
		short int	x1, y1 ;	/*  1_W	*/
		short int	x2, y2 ;	/*  2_W	*/
	} para ;									/*  EGB֐p		*/

	para.n  = 2 ;
	para.x1 = x1 ;
	para.y1 = y1 ;
	para.x2 = x2 ;
	para.y2 = y2 ;
	EGB_connect( Gwork,(char *)&para ) ;		/*  A`			*/
}

void triangle( int x1,int y1,int x2,int y2,int x3,int y3 )
/*===========================================================================
*	Op``
===========================================================================*/
{
	struct {
		short int	x1, y1 ;	/*  1_W	*/
		short int	x2, y2 ;	/*  2_W	*/
		short int	x3, y3 ;	/*  3_W	*/
	} para ;									/*  EGB֐p		*/

	para.x1 = x1 ;
	para.y1 = y1 ;
	para.x2 = x2 ;
	para.y2 = y2 ;
	para.x3 = x3 ;
	para.y3 = y3 ;
	EGB_triangle( Gwork,(char *)&para ) ;		/*  Op``			*/
}

void box( int x1,int y1,int x2,int y2 )
/*===========================================================================
*	``
===========================================================================*/
{
	struct {
		short int	x1, y1 ;	/*  1_W	*/
		short int	x2, y2 ;	/*  2_W	*/
	} para ;									/*  EGB֐p		*/

	para.x1 = x1 ;
	para.y1 = y1 ;
	para.x2 = x2 ;
	para.y2 = y2 ;
	EGB_rectangle( Gwork,(char *)&para ) ;		/*  ``			*/
}

void ellipse( int x,int y,int dx,int dy )
/*===========================================================================
*	ȉ~`
===========================================================================*/
{
	struct {
		short int	x, y ;		/*  S_W	*/
		short int	dx, dy ;	/*  X,Y		*/
	} para ;									/*  EGB֐p		*/

	para.x  = x ;
	para.y  = y ;
	para.dx = dx ;
	para.dy = dy ;
	EGB_ellipse( Gwork,(char *)&para ) ;		/*  ȉ~`			*/
}

void paint( int x,int y,int color )
/*===========================================================================
*	ʓh
===========================================================================*/
{
	struct {
		short int	x, y ;		/*  X,YW	*/
	} para ;									/*  EGB֐p		*/

	EGB_color( Gwork,C_PAINT,color ) ;			/*  `Fݒ			*/
	para.x  = x ;
	para.y  = y ;
	EGB_closePaint( Gwork,(char *)&para ) ;		/*  ̈hׂ		*/
}

void glocate( int x,int y )
/*===========================================================================
*	÷ĕ\ʒuݒ(̨W)
===========================================================================*/
{
	struct {
		short int	x, y ;		/*  X,YW		*/
		short int	len ;		/*  	*/
	} para ;									/*  EGB֐p		*/

	para.x   = x ;
	para.y   = y ;
	para.len = 0 ;
	EGB_sjisString( Gwork,(char *)&para ) ;		/*  ̏		*/
}

void locate( int clmn,int row )
/*===========================================================================
*	÷ĕ\ʒuݒ(÷čW)
*	< IN  >	: clmn	(1`)
*			: row	s(1`)
===========================================================================*/
{
	clmn = ( clmn - 1 ) * __gdotx ;				/*  XW			*/
	row  = row * __gdoty - 1 ;					/*  sYW			*/
	glocate( clmn,row ) ;						/*  `Jnʒu		*/
}

void _gputc( int ch )
/*===========================================================================
*	`(ROM̫)
===========================================================================*/
{
	struct {
		short int	len ;
		char	str[2] ;
	} para ;									/*  `p		*/

	para.len = 1 ;
	para.str[0] = (char)ch ;
	para.str[1] = '\0' ;
	EGB_connectSjisString( Gwork,(char *)&para ) ;	/*  \		*/
}

void _gputs( char *str )
/*===========================================================================
*	`(ROM̫)
===========================================================================*/
{
	struct {
		short int	len ;
		char	str[128] ;
	} para ;									/*  `p		*/

	para.len = strlen( str ) ;
	strcpy( para.str,str ) ;
	EGB_connectSjisString( Gwork,(char *)&para ) ;	/*  \		*/
}

void _gprintf( char *form,... )
/*===========================================================================
*	t`(ROM̫)
===========================================================================*/
{
	va_list	argptr ;

	va_start( argptr,form ) ;
	vsprintf( __gstrbuf,form,argptr ) ;
	_gputs( __gstrbuf ) ;
	va_end( argptr ) ;
}

void gput( int x1,int y1,int x2,int y2,int pixel,unsigned int ptr )
/*===========================================================================
*	`撣t
===========================================================================*/
{
	struct {
		long int	ptr ;		/*  i[ڽ	*/
		short int	ds ;		/*  ްڸ	*/
		short int	x1, y1 ;	/*  1_W	*/
		short int	x2, y2 ;	/*  2_W	*/
	} para ;									/*  EGB֐p		*/

	para.ptr = ptr ;
	para.ds  = getds() ;
	para.x1  = x1 ;
	para.y1  = y1 ;
	para.x2  = x2 ;
	para.y2  = y2 ;
	if ( pixel == 1 )
		EGB_putBlockColor( Gwork,1,(char *)&para ) ;	/*  PF		*/
	else
		EGB_putBlock( Gwork,1,(char *)&para ) ;			/*  F		*/
}

void gget( int x1,int y1,int x2,int y2,unsigned int ptr )
/*===========================================================================
*	`荞(FӰޗp)
===========================================================================*/
{
	struct {
		long int	ptr ;		/*  i[ڽ	*/
		short int	ds ;		/*  ްڸ	*/
		short int	x1, y1 ;	/*  1_W	*/
		short int	x2, y2 ;	/*  2_W	*/
	} para ;									/*  EGB֐p		*/

	para.ptr = ptr ;
	para.ds  = getds() ;
	para.x1  = x1 ;
	para.y1  = y1 ;
	para.x2  = x2 ;
	para.y2  = y2 ;
	EGB_getBlock( Gwork,(char *)&para ) ;
}

void convFontY( void )
/*===========================================================================
*	ROM̫Ăc24ޯĂɉH
===========================================================================*/
{
	register int	sp, dp ;
	char	wk[32] ;

	memcpy( wk,FontData,32 ) ;
	for ( sp=0, dp=0; sp<32; sp+=4, dp+=6 ) {
		FontData[dp+0] = wk[sp] ;
		FontData[dp+1] = wk[sp+1] ;
		FontData[dp+2] = wk[sp+0] | wk[sp+2] ;
		FontData[dp+3] = wk[sp+1] | wk[sp+3] ;
		FontData[dp+4] = wk[sp+2] ;
		FontData[dp+5] = wk[sp+3] ;
	}
}

void dispAscii24( int code )
/*===========================================================================
*	ASCII\(c24ޯ)
===========================================================================*/
{
	register int	off ;

	FNT_ankRead( 8,16,code,getds(),FontData ) ;
	for ( off=15; off>=0; off-- ) {
		FontData[off+off+1] = 0 ;
		FontData[off+off] = FontData[off] ;
	}
	convFontY() ;								/*  ROM̫Ăc24ޯĂ	*/
	EGB_anyChar( Gwork,__gdotx+__gdotx,__gdoty,FontData ) ;
	EGB_textSpace( Gwork,-__gdotx+__gdots ) ;
}

void dispSjis24( int sjis )
/*===========================================================================
*	JIS\(c24ޯ)
===========================================================================*/
{
	int		code ;

	code = FNT_sjisToJis( sjis ) ;
	FNT_kanjiRead( 16,16,code,getds(),FontData ) ;
	convFontY() ;								/*  ROM̫Ăc24ޯĂ	*/
	EGB_anyChar( Gwork,__gdotx+__gdotx,__gdoty,FontData ) ;
	EGB_textSpace( Gwork,__gdots ) ;
}

void gputs24( const char *str )
/*===========================================================================
*	\(c24ޯ)
===========================================================================*/
{
	register int	kanji ;
	int		code ;

	EGB_textZoom( Gwork,0,8,24 ) ;				/*  ANK		*/
	EGB_textZoom( Gwork,1,16,24 ) ;				/*  	*/
	while ( *str ) {
		if ( iskanji( *str ) ) {
			code = *str << 8 ;
			str++ ;
			code |= *str ;
			kanji = TRUE ;
		} else {
			code = *str ;
			kanji = FALSE ;
		}
		str++ ;
		if ( kanji ) {								/*  	*/
			dispSjis24( code ) ;
		} else {									/*  ANK		*/
			dispAscii24( code ) ;
		}
	}
	EGB_textZoom( Gwork,0,__gdotx,__gdoty ) ;			/*  ANK		*/
	EGB_textZoom( Gwork,1,__gdotx+__gdotx,__gdoty ) ;	/*  	*/
	EGB_textSpace( Gwork,__gdots ) ;
}

void gprintf24( char *form,... )
/*===========================================================================
*	t`(c24ޯ)
===========================================================================*/
{
	va_list	argptr ;

	va_start( argptr,form ) ;
	vsprintf( __gstrbuf,form,argptr ) ;
	gputs24( __gstrbuf ) ;
	va_end( argptr ) ;
}

void dispAscii( int code )
/*===========================================================================
*	ASCII\(̫)
===========================================================================*/
{
	int		off, err=FALSE ;
	FILE	*fp ;
	int		xsize=FontDots, ysize=FontDots ;

	if ( xsize == 60 ) xsize = 64 ;
	if ( FontType == 0 || FontType == 1 ) {		/*  Sp	*/
		fp = FontFp[2] ;
		off = code * (FontSize+2) ;
	} else {									/*  p	*/
		fp = FontFp[0] ;
		off = code * (FontSize/2) + 16 ;
		xsize >>= 1 ;
		EGB_textZoom( Gwork,1,__gdotx,__gdoty ) ;
	}
	if ( fp == NULL ) {
		err = TRUE ;
	} else {
		if ( off < 0 ) {
			err = TRUE ;
		} else {
			if ( fseek( fp,off,SEEK_SET ) ) {
				err = TRUE ;
			} else {
				err = loadFont( fp,code,FALSE ) ;
			}
		}
	}
	if ( err ) {								/*  ROM̫				*/
		_gputc( code ) ;
		EGB_textSpace( Gwork,__gdots ) ;
	} else {									/*  C̫			*/
		EGB_anyChar( Gwork,xsize,ysize,FontData ) ;
		if ( xsize == 64 ) xsize = 60 ;
		if ( xsize == FontDots ) {				/*  Sp̎			*/
			EGB_textSpace( Gwork,-__gdotx+__gdots ) ;	/*  p߂	*/
		} else {
			EGB_textSpace( Gwork,__gdots ) ;
		}
	}
	EGB_textZoom( Gwork,1,__gdotx+__gdotx,__gdoty ) ;	/*  	*/
}

void dispSjis( int sjis )
/*===========================================================================
*	JIS\(̫)
===========================================================================*/
{
	int		off, err=FALSE ;
	int		code ;
	FILE	*fp ;
	char	str[3] ;
	int		xsize=FontDots, ysize=FontDots ;

	if ( xsize == 60 ) xsize = 64 ;
	fp = FontFp[0] ;
	code = sjis ;
	off = getFontOffset( &code ) ;				/*  i[ʒu擾		*/
	if ( fp == NULL ) {
		err = TRUE ;
	} else {
		if ( off < 0 ) {
			err = TRUE ;
		} else {
			if ( fseek( fp,off,SEEK_SET ) ) {
				err = TRUE ;
			} else {
				err = loadFont( fp,code,TRUE ) ;
			}
		}
	}
	if ( err ) {
		str[0] = (char)( sjis >> 8 ) ;
		str[1] = (char)( sjis & 0xFF ) ;
		str[2] = '\0' ;
		_gputs( str ) ;
	} else {
		EGB_anyChar( Gwork,xsize,ysize,FontData ) ;
	}
	EGB_textSpace( Gwork,__gdots ) ;
}

void gputs2( const char *str )
/*===========================================================================
*	̫ĕ\
===========================================================================*/
{
	int		kanji ;
	int		code ;

	while ( *str ) {
		if ( iskanji( *str ) ) {
			code = *str << 8 ;
			str++ ;
			code |= *str ;
			kanji = TRUE ;
		} else {
			code = *str ;
			kanji = FALSE ;
		}
		str++ ;
		if ( kanji ) {							/*  	*/
			dispSjis( code ) ;
		} else {								/*  ANK		*/
			dispAscii( code ) ;
		}
	}
	EGB_textSpace( Gwork,__gdots ) ;
}

void gprintf2( char *form,... )
/*===========================================================================
*	t`(̫)
===========================================================================*/
{
	va_list	argptr ;

	va_start( argptr,form ) ;
	vsprintf( __gstrbuf,form,argptr ) ;
	gputs2( __gstrbuf ) ;
	va_end( argptr ) ;
}

void setTextSpace( int size )
/*===========================================================================
*	ԋ󔒂ޯĐݒ
===========================================================================*/
{
	__gdots = size ;
	EGB_textSpace( Gwork,__gdots ) ;			/*  ԋ󔒐ݒ		*/
}

void setTextSize( int xsize,int ysize )
/*===========================================================================
*	ސݒ
*	< IN  >	: xsize	ANK̉({l̉ނƂ)
*			: ysize	ANK/̏c
===========================================================================*/
{
	__gdotx = xsize ;
	__gdoty = ysize ;
	EGB_textZoom( Gwork,0,__gdotx,__gdoty ) ;			/*  ANK		*/
	EGB_textZoom( Gwork,1,__gdotx+__gdotx,__gdoty ) ;	/*  	*/
}

void setTextType( int type )
/*===========================================================================
*	\̐ݒ
*	̫Ďw莞, fotnOpen֐callKv
===========================================================================*/
{
	switch ( type ) {
	case F_ROM24:
	case F_FILE	:	__gtype = type ;		break ;
	case F_ROM	:
	default		:	__gtype = F_ROM ;
	}
}

void gputc( int ch )
/*===========================================================================
*	`
===========================================================================*/
{
	switch ( __gtype ) {
	case F_ROM24:
		EGB_textZoom( Gwork,0,8,24 ) ;						/*  ANK		*/
		EGB_textZoom( Gwork,1,16,24 ) ;						/*  	*/
		dispAscii24( ch ) ;
		EGB_textZoom( Gwork,0,__gdotx,__gdoty ) ;			/*  ANK		*/
		EGB_textZoom( Gwork,1,__gdotx+__gdotx,__gdoty ) ;	/*  	*/
		break ;
	case F_FILE	:
		dispAscii( ch ) ;
		break ;
	case F_ROM	:
	default		:
		_gputc( ch ) ;
	}
	EGB_textSpace( Gwork,__gdots ) ;
}

void gputs( char *str )
/*===========================================================================
*	`
===========================================================================*/
{
	switch ( __gtype ) {
	case F_ROM24:	gputs24( str ) ;	break ;
	case F_FILE	:	gputs2( str ) ;		break ;
	case F_ROM	:
	default		:	_gputs( str ) ;
	}
}

void gprintf( char *form,... )
/*===========================================================================
*	t`
===========================================================================*/
{
	va_list	argptr ;

	va_start( argptr,form ) ;
	vsprintf( __gstrbuf,form,argptr ) ;
	gputs( __gstrbuf ) ;
	va_end( argptr ) ;
}

/*	HISTORY
-----------------------------------------------------------------------------
*	1991.04.13 : CREATE
*	1993.08.09 : remake
---------------------------------------------------------------------------*/
